Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.sql
Interface DataSource

public interface DataSource

A factory for connections to the physical data source that this `DataSource` object represents. An alternative to the `DriverManager` facility, a `DataSource` object is the preferred means of getting a connection. An object that implements the `DataSource` interface will typically be registered with a naming service based on the JavaTM Naming and Directory (JNDI) API.

The `DataSource` interface is implemented by a driver vendor. There are three types of implementations:

1. Basic implementation -- produces a standard `Connection` object
2. Connection pooling implementation -- produces a `Connection` object that will automatically participate in connection pooling. This implementation works with a middle-tier connection pooling manager.
3. Distributed transaction implementation -- produces a `Connection` object that may be used for distributed transactions and almost always participates in connection pooling. This implementation works with a middle-tier transaction manager and almost always with a connection pooling manager.

A `DataSource` object has properties that can be modified when necessary. For example, if the data source is moved to a different server, the property for the server can be changed. The benefit is that because the data source's properties can be changed, any code accessing that data source does not need to be changed.

A driver that is accessed via a `DataSource` object does not register itself with the `DriverManager`. Rather, a `DataSource` object is retrieved though a lookup operation and then used to create a `Connection` object. With a basic implementation, the connection obtained through a `DataSource` object is identical to a connection obtained through the `DriverManager` facility.

Since:
  1.4

Method Summary
`Connection` | `getConnection()` Attempts to establish a connection with the data source that this `DataSource` object represents.
`Connection` | `getConnection(String username, String password)` Attempts to establish a connection with the data source that this `DataSource` object represents.
`int` | `getLoginTimeout()` Gets the maximum time in seconds that this data source can wait while attempting to connect to a database.
`PrintWriter` | `getLogWriter()` Retrieves the log writer for this `DataSource` object.
`void` | `setLoginTimeout(int seconds)` Sets the maximum time in seconds that this data source will wait while attempting to connect to a database.
`void` | `setLogWriter(PrintWriter out)` Sets the log writer for this `DataSource` object to the given `java.io.PrintWriter` object.

Method Detail

### getConnection

    public Connection getConnection()
                             throws SQLException

  Attempts to establish a connection with the data source that this `DataSource` object represents.

  Returns:
    a connection to the data source
  Throws:
    `SQLException` - if a database access error occurs

### getConnection

    public Connection getConnection(String username,
                                    String password)
                             throws SQLException

  Attempts to establish a connection with the data source that this `DataSource` object represents.

  Parameters:
    `username` - the database user on whose behalf the connection is being made
    `password` - the user's password
  Returns:
    a connection to the data source
  Throws:
    `SQLException` - if a database access error occurs

### getLogWriter

    public PrintWriter getLogWriter()
                             throws SQLException

  Retrieves the log writer for this `DataSource` object.

  The log writer is a character output stream to which all logging and tracing messages for this data source will be printed. This includes messages printed by the methods of this object, messages printed by methods of other objects manufactured by this object, and so on. Messages printed to a data source specific log writer are not printed to the log writer associated with the `java.sql.Drivermanager` class. When a `DataSource` object is created, the log writer is initially null; in other words, the default is for logging to be disabled.

  Returns:
    the log writer for this data source or null if logging is disabled
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setLogWriter(java.io.PrintWriter)`

### setLogWriter

    public void setLogWriter(PrintWriter out)
                      throws SQLException

  Sets the log writer for this `DataSource` object to the given `java.io.PrintWriter` object.

  The log writer is a character output stream to which all logging and tracing messages for this data source will be printed. This includes messages printed by the methods of this object, messages printed by methods of other objects manufactured by this object, and so on. Messages printed to a data source- specific log writer are not printed to the log writer associated with the `java.sql.Drivermanager` class. When a `DataSource` object is created the log writer is initially null; in other words, the default is for logging to be disabled.

  Parameters:
    `out` - the new log writer; to disable logging, set to null
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getLogWriter()`

### setLoginTimeout

    public void setLoginTimeout(int seconds)
                         throws SQLException

  Sets the maximum time in seconds that this data source will wait while attempting to connect to a database. A value of zero specifies that the timeout is the default system timeout if there is one; otherwise, it specifies that there is no timeout. When a `DataSource` object is created, the login timeout is initially zero.

  Parameters:
    `seconds` - the data source login time limit
  Throws:
    `SQLException` - if a database access error occurs.
  See Also:
    `getLoginTimeout()`

### getLoginTimeout

    public int getLoginTimeout()
                        throws SQLException

  Gets the maximum time in seconds that this data source can wait while attempting to connect to a database. A value of zero means that the timeout is the default system timeout if there is one; otherwise, it means that there is no timeout. When a `DataSource` object is created, the login timeout is initially zero.

  Returns:
    the data source login time limit
  Throws:
    `SQLException` - if a database access error occurs.
  See Also:
    `setLoginTimeout(int)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.